



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>淘宝(阿里百川)手机客户端开发日记第四篇 自定义ListView详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">淘宝(阿里百川)手机客户端开发日记第四篇 自定义ListView详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 04:22:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>我们知道，如果采用官方的ListView,实现的功能在很多时候，并不能满足自己的业务需求，比如在设计到复杂的列表的时候，这一节，我们就开始动手自己实现自定义的ListView.</p>
<p>在上一节中，我们采用了固定的ListView中的数据集，我们对其进行改造；我们重新设置一个ListView的一个模板</p>
<p>template_sort.xml</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
    android:layout_width="match_parent"
    android:layout_height="match_parent"
    android:orientation="horizontal" &gt;

    &lt;TextView
        android:id="@+id/tvSortID"
        android:layout_width="wrap_content"
        android:layout_height="wrap_content"
        android:layout_marginLeft="10dp"
        android:text="1"
        android:textSize="24sp" /&gt;

    &lt;TextView
        android:id="@+id/tvSortName"
        android:layout_width="wrap_content"
        android:layout_height="25dp"
        android:layout_marginLeft="10dp"
        android:text="内容"
        android:textSize="24sp" /&gt;

&lt;/LinearLayout&gt;
</pre>
</div>
<p>我们还需要自己添加一个业务bean,起名叫PSort类</p>
<div>
<pre class="prettyprint linenums">package com.example.bean;

public class PSort {
	//分类ID
　　　　	private int id;
　　　　 //分类名称　　 	private String name;

	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
}
</pre>
</div>
<p>如果自定义ListView,我们还需要自己定义一个适配器，这里我起名叫MySortAdapter</p>
<div>
<pre class="prettyprint linenums">package com.example.adapter;

import java.util.List;

import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;
import android.widget.Toast;

import com.example.bean.PSort;
import com.example.slidepaneldemo.R;

public class MySortAdapter extends BaseAdapter {

	private List&lt;PSort&gt; list;

	private Context context;
　　　　 //更新主框架的UI　　	private Handler mHandle;

	public MySortAdapter(List&lt;PSort&gt; list,Context context,Handler mHandle)
	{
		this.list= list;
		this.context = context;
		this.mHandle = mHandle;
	}

	@Override
	public int getCount() {

		return list.size();
	}

	@Override
	public PSort getItem(int position) {

		return list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, final ViewGroup parent)  {
		MyViewHolder myHolder;
		if(convertView == null)
		{
			LayoutInflater inflater = LayoutInflater.from(context);
			convertView = inflater.inflate(R.layout.template_sort, null);

			myHolder = new MyViewHolder();
			myHolder.tvSortID = (TextView) convertView.findViewById(R.id.tvSortID);
			myHolder.tvSortName = (TextView) convertView.findViewById(R.id.tvSortName);
		}
		else {
			myHolder = (MyViewHolder) convertView.getTag();
		}
		final PSort pSort = list.get(position);
		myHolder.tvSortID.setText(String.valueOf(pSort.getId()));
		myHolder.tvSortName.setText(pSort.getName());
		myHolder.tvSortName.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View view) {
　　　　　　　　　　　　　　　　　　　// 点击一个Item时，向主框架发送异步信息，来更新数据
       				Message msg = new Message();
				msg.what = position;
				mHandle.sendMessage(msg);

			}
		});
		return convertView;
	}

	static class MyViewHolder
	{
		public  TextView tvSortID;
		public  TextView tvSortName;
	}

}
</pre>
</div>
<p>主框架代码部分：MainActivity.java</p>
<div>
<pre class="prettyprint linenums">package com.example.slidepaneldemo;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v4.widget.SlidingPaneLayout;
import android.support.v4.widget.SlidingPaneLayout.PanelSlideListener;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.adapter.MySortAdapter;
import com.example.bean.PSort;

public class MainActivity extends Activity implements PanelSlideListener {

	Button button1;
	SlidingPaneLayout slidepanel;
	ListView lvItems;
	TextView textView1;
	List&lt;PSort&gt; list;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		button1 = (Button)findViewById(R.id.button1);
		slidepanel = (SlidingPaneLayout)findViewById(R.id.slidepanel);
		lvItems = (ListView)findViewById(R.id.lvItems);
		textView1 = (TextView)findViewById(R.id.textView1);

		list = new ArrayList&lt;PSort&gt;();
		for(int i=0;i&lt;5;i++)
		{
			PSort p = new PSort();
			p.setId(i+1);
			p.setName("Sort" + String.valueOf(i+1));
			list.add(p);
		}

		lvItems.setAdapter(new MySortAdapter(list,this,handler));

		button1.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				if(!slidepanel.isOpen())
				{
					slidepanel.openPane();
				}
				else
				{
					slidepanel.closePane();
				}
			}
		});
	}

	Handler handler = new Handler()
	{
		@Override
		public void handleMessage(Message msg) {
			//Toast.makeText(MainActivity.this, "Id:" + msg.what, 1).show();

			textView1.setText(list.get(msg.what).getName());
			slidepanel.closePane();

		}
	};

	@Override
	public void onPanelClosed(View arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onPanelOpened(View arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onPanelSlide(View arg0, float arg1) {
		// TODO Auto-generated method stub

	}

}
</pre>
</div>
<p><img referrerpolicy="no-referrer"src="http://images0.cnblogs.com/blog2015/734467/201506/291748138999134.png" /></p>
<p>这个时候，当我们点击左边分类的时候，就可以更新右边的数据啦！</p>
<p>转载请注明http://www.cnblogs.com/yushengbo,否则将追究版权责任！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pp2wy9.html">OOM killer</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jgez8.html">PHP面向对象讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rynzm8.html">python thrift 服务端与客户端使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnyj1j8.html">AXUre</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyo0zd8.html">java设计模式之命令模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyxyxd8.html">MyBatis学习--查询缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jr22lq.html">利用Jquery的load函数实现页面的动态加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j00270q.html">JAVA学习提高之－－－－安装多个JDK版本的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm51579.html">xv6实验环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd0njjq.html">GC roots 总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn6dwrq.html">adt-bundle-linux-x86&lowbar;64-20131030下新建project提示找不到adb和R&period;java问题的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyly7x9.html">Java进阶&lpar;七&rpar;Java加密技术之非对称加密算法RSA</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ox2wg8.html">Log4Net 常见格式说明（不断更新中）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e410pe9.html">thinkphp5&period;0如何隐藏index&period;php入口文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25wvglq.html">scipy 的K-means</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwjjlj9.html">web自动化&amp;&num;160&semi;基于python&plus;Selenium&plus;PHP&plus;Ftp实现的轻量级web自动化测试框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdegvv9.html">&lbrack;转&rsqb; Mongoose初使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r533ldq.html">【Shell】获取当前路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllr0meq.html">浅谈线程runnable和callable的使用及区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko4gn3q.html">Android中的资源与国际化&excl;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8kyrd39.html">用Wireshark抓包分析超过70秒的请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/4954nzmq.html">ejs</a>
			</li>
						<li><a href="https://www.batexi.com/a/4954ynmq.html">JavaScript事件---事件绑定和深入</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q76wve8.html">SimpleDateFormat出错</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv6ol18.html">Mac上git的安装配置与使用简述</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zdp4d9.html">压缩算法实现之LZ78</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ky6d79.html">nginx下禁止访问robots&period;txt的设置方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw1mkr8.html">Java 集合类详解（含类图）</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdn2lz9.html">SpringMVC实现一个controller里面有多个方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96xery9.html">java订电影票系统</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
